


extern char *txt;
extern unsigned int i,j,k;
extern char addr;
extern char CRam1[];



int LCD2119_Init(void);
void RAZ_UART1(void);
void Init_Timer0(void);
void UART1_Write_CText(const char *txt1);
void strConstRamCpy(char *dest, const char *source);
void CRLF1(void);
void LCD_CLS(void);
void LCD_Cde(unsigned char Cde);
void LCD_Clear(void); // <-- PB >> au lieu de space..  suivre
int LCD2119_Init(void);
void LCD_RAZ_Ligne(int L);
void check_device(unsigned char dev_address);
void LCD_Write_Chr_At(int Ligne,int Col,char c1) ;
void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1);
void LCD_Write_Text(char * t1);
void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1);



void LCD_CLS()
{
// d'abord la ligne 2 pour avoir le curseur en 0 de ligne 1
LCD_RAZ_Ligne(2);
LCD_RAZ_Ligne(1);
}

void LCD_Clear()
{
 // problematique !!!!
 //  suivre...
int j;
I2C1_Start();
j=I2C1_Wr(addr); // i2c slave Address
j=I2C1_Wr(0x00);    // Control byte for Instruction
j=I2C1_Wr(0x01); // clear display
I2C1_Stop();
}


int LCD2119_Init(void)
{
int j,k;
k=0;
Delay_ms(500);
I2C1_Start();
j=I2C1_Wr(addr); // i2c slave Address
if (j!=0) return k;
k++;
Delay_ms(100);
j=I2C1_Wr(0x00);    // Control byte for Instruction
if (j>0) return k;
k++;
I2C1_Wr(0x34);    // DL: 8 bits, M: 16 by two line display, SL: 1:18, H: normal instruction set
I2C1_Wr(0x0C); // D: Display on, C: curser off, B: blink off
I2C1_Wr(0x06);    // I/D: increment, S: no shift
I2C1_Wr(0x35); // DL: 8 bits, M: 16 by two line, SL: 1:18, H: extended instruction set
//I2C1_Wr(0x04); // P: left to right, Q: top to bottom    sur connecteur A
I2C1_Wr(0x06); // P: Right to left ,Q: top to bottom      sur connecteur B
I2C1_Wr(0x11); // TC1: 0, TC0: 1
I2C1_Wr(0x42); // HV Stages 3
//I2C1_Wr(0x9f); // set Vlcd, store to VA
I2C1_Wr(0x96); // set Vlcd, store to VA
j=I2C1_Wr(0x34); // DL: 8 bits, M: two line, SL: 1:18, H: normal instruction set
if (j>0) return k;
k++;
j=I2C1_Wr(0x80); // DDRAM Address set to 00hex
if (j>0) return k;
k++;
j=I2C1_Wr(0x02); // return home
if (j>0) return k;
k++;
//  j=I2C1_Wr(0x01); // clear display   inhib car affiche >> >> >> because ROM char !
if (j>0) return k;
k++;
I2C1_Stop();
return k;
}

void LCD_RAZ_Ligne( int L)
{ int i;
 I2C1_Start();
 I2C1_Wr(addr); // i2c slave Address
 I2C1_Wr(0x00); // Control byte for Instruction
 I2C1_Wr(0x02); // return home
 switch (L)
 {
  case 1:
      I2C1_Wr(0x80); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C1_Wr(0xC0); // DDRAM Address 2em ligne
      break;
  default:
  break ;
 }
 I2C1_Repeated_Start();
 I2C1_Wr(addr); // i2c slave Adress
 I2C1_Wr(0x40);     // Control byte for Data
 for (i=0;i<39;i++)
 {
   I2C1_Wr(0x80+32); // efface avec des blanc
 }
 // repositionne au debut de ligne
 I2C1_Repeated_Start();
 I2C1_Wr(addr); // i2c slave Adress
 I2C1_Wr(0x00); // Control byte for Instruction
 //I2C1_Wr(0x40);     // Control byte for Data
 switch (L)
  {
   case 1:
         I2C1_Wr(0x80); // DDRAM Address 1ere ligne
        break;
   case 2:
        I2C1_Wr(0xC0); // DDRAM Address 2em ligne
        break;
   default:
        break ;
  }
 I2C1_Stop();
}


void LCD_Home()
{
 LCD_Cde(0x02);
}


void LCD_Droite()
{
  LCD_Cde(0x014);
 }

void LCD_Cde(unsigned char Cde)
{
 I2C1_Start();
 I2C1_Wr(0x76); //Display adress
 I2C1_Wr(0x00); //Register Select Config Register
 I2C1_Wr(Cde); //Write Data
 I2C1_Stop();
}

void LCD_Gauche()
{
  LCD_Cde(0x010);
 }

void Cree_8_cars_CGRAM()
{
unsigned char b1,b2;
 I2C1_Start();
 I2C1_Wr(addr); // i2c slave Adress
 I2C1_Wr(0x00);
 // Cde Set_CGRAM address to 0  =>  (0x40 + adresse=0 )
 I2C1_Wr(0x40);
// I2C1_Start();
 I2C1_Repeated_Start() ;
 I2C1_Wr(addr); // i2c slave Adress
 I2C1_Wr(0x40);// set CGRAM adress
 //Probleme : 5 pixels seulement accessibles en largeur (sur 8)
// blanc
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
  b2=32;
  b1=0;
  for (i=0;i<5;i++)
  {
   b2=b2>>1;
   b1=b1+b2;
   for (j=0;j<8;j++)
   {
   #ifdef With_UART
     UART1_Write_CText("I2C1_Wr(");
     Decompile_byte(b1);
     CRLF1();
     #endif
     I2C1_Wr(b1);

   }
   #ifdef With_UART
    CRLF1();
    #endif
  }
  // petit rectangle
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0011111);
I2C1_Wr(0b0010001);
I2C1_Wr(0b0011111);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);

// The Euro currency character can be recognized by the 0/1 pattern (see Figure 48)
I2C1_Wr(0x06); // 00110
I2C1_Wr(0x09); // 01001
I2C1_Wr(0x08); // 01000
I2C1_Wr(0x1E); // 11110
I2C1_Wr(0x1E); // 11110
I2C1_Wr(0x08); // 01000
I2C1_Wr(0x09); // 01001
I2C1_Wr(0x06); // 00110
I2C1_Stop();
}


void Cree_Euro()
{
I2C1_Start();
// PCF2119 slave address for write, SA0 is connected to Vdd
I2C1_Wr(addr); // i2c slave Adress
// MSB (Continuation bit Co) = 0, more than one byte may follow. Bit6, RS=0, next byte
// is command byte
I2C1_Wr(0x00);
// 2 lines x 16, 1/18 duty, basic instruction set. Next byte will be another command.
//I2C1_Wr(0x24);
I2C1_Wr(0x06); // Entry mode set : I/D: increment, S: no shift
//I2C1_Wr(0xC0);  // DDRam adresse remark page 35
// Cde Set_CGRAM address to 0  =>  (0x40 + adresse=0 )
I2C1_Wr(0x40);
//I2C1_Stop();
// Repeated Start condition
 I2C1_Repeated_Start() ;
I2C1_Wr(addr); // i2c slave Adress
// RS=1, next byte is a data byte
I2C1_Wr(0x40);// set CGRAM adress
// Here the data bytes to define the character
// Behind the write commands the 5x8 dot matrix is shown, the 1 represents a on pixel.
// The Euro currency character can be recognized by the 0/1 pattern (see Figure 48)
I2C1_Wr(0x06); // 00110
I2C1_Wr(0x09); // 01001
I2C1_Wr(0x08); // 01000
I2C1_Wr(0x1E); // 11110
I2C1_Wr(0x1E); // 11110
I2C1_Wr(0x08); // 01000
I2C1_Wr(0x09); // 01001
I2C1_Wr(0x06); // 00110
I2C1_Stop();
}



void upside_down(void)
{
I2C1_Start();
I2C1_Wr(addr);
I2C1_Wr(0x00); // Control byte for Instruction
I2C1_Wr(0x35); // DL: 8 bits, M: 16 by two line, SL: 1:18, H: extended instruction set
//I2C1_Wr(0x07); // P=1; Q=1;
I2C1_Wr(0x04); // P=1; Q=0;

I2C1_Stop();
}

void normal(void)
{
I2C1_Start();
I2C1_Wr(addr);
I2C1_Wr(0x00); // Control byte for Instruction
I2C1_Wr(0x35); // DL: 8 bits, M: 16 by two line, SL: 1:18, H: extended instruction set
//I2C1_Wr(0x04); // P=1; Q=0;
I2C1_Wr(0x06); // P=1; Q=1;
I2C1_Stop();
}

void check_device(unsigned char dev_address)
{
strConstRamCpy(txt,"Device at adresse : ");
k=strlen(txt);
ByteToStr(dev_address,CRam1);
strcat(txt+k,CRam1);
UART1_Write_Text(txt);
I2C1_Start();
if(I2C1_Wr(dev_address)!=0 )
 {
  UART1_Write_CText(" is not found");
 }
 else
 {
  UART1_Write_CText(" found OK");
  }
I2C1_Stop();
 CRLF1();
}

void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1)
 {
  char TT[17];
  int i;
  strConstRamCpy(TT,t1);
  I2C1_Start();
  I2C1_Wr(addr); // i2c slave Address
  I2C1_Wr(0x00); // Control byte for Instruction
  if(col>16) col=16;
  switch (Ligne)
 {
  case 1:
      I2C1_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C1_Wr(0xc0+col-1); // DDRAM Address 2em ligne
        break;
  default:
  break ;
 }
 I2C1_Repeated_Start();
 I2C1_Wr(addr); // i2c slave Adress
 I2C1_Wr(0x40); // Control byte for Data
 i=0;
 while(*(t1))
 {
  I2C1_Wr(0x80+*(t1));
  t1++;
  i++;
  if (i>16) break;
 }
 I2C1_Stop();
}



void LCD_Write_Chr_At(int Ligne,int col,char c1)
{ //.. ligne 1 ou 2
  //.. col de 1  16
  // .. Special =0 pour ascii normal   1 pour caracteres perso definis en CGRAM
  I2C1_Start() ;
  I2C1_Wr(addr); // i2c slave Adress
  I2C1_Wr(0x00); // Control byte for Instruction
  if(col>16) col=16;
  switch (Ligne)
  {
  case 1:
      I2C1_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C1_Wr(0xc0+col-1); // DDRAM Address 2em ligne
      break;
  default:
      break ;
  }
  I2C1_Repeated_Start() ;
  I2C1_Wr(addr); // i2c slave Address
  I2C1_Wr(0x40); // Control byte for Data
  I2C1_Wr(0x80+c1);
  Delay_ms(10);                      // Pause de 10ms
  I2C1_Stop();
 }
 

void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1)
{ //.. ligne 1 ou 2
  //.. col de 1  16
  int i;
  I2C1_Start();
  I2C1_Wr(addr); // i2c slave Address
  I2C1_Wr(0x00); // Control byte for Instruction
  if(col>16) col=16;
  switch (Ligne)
  {
  case 1:
      I2C1_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C1_Wr(0xc0+col-1); // DDRAM Address 2em ligne
      break;
  default:
      break ;
  }
  I2C1_Repeated_Start();
  I2C1_Wr(addr); // i2c slave Adress
  I2C1_Wr(0x40); // Control byte for Data
  i=0;
  while(*(t1))
  {
  I2C1_Wr(0x80+*(t1));
  t1++;
  i++;
  if (i>16) break;
  }
  I2C1_Stop();
}

void LCD_Write_Text(char * t1)
{  int i;
  I2C1_Start();
  I2C1_Wr(addr); // i2c slave Adress
  I2C1_Wr(0x40); // Control byte for Data
  i=0;
  while(*(t1))
  {
  I2C1_Wr(0x80+*(t1));
  t1++;
  i++;
  if (i>16) break;
  }
  I2C1_Stop();
}

void Decompile_byte(unsigned char un)
{
 unsigned char masque;
 masque = 0x80;
 while (masque > 0u )
 {
   if ((un & masque)>0)
       UART1_Write(49u);  //  '1'
    else
       UART1_Write(48u);  //  '0'
    masque =masque >>1;
  }
}